<script lang="ts">
import { Faq } from '../common/index.vue';

export default {
  name: 'DibMarketplace',
  components: { Faq },
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
    quote: {
      type: Object,
      required: true,
      default: null,
    },
    faq: {
      type: Object,
      required: true,
      default: null,
    },
  },
  data() {
    return {
      showMore: false,
    };
  },
};
</script>

<template>
  <section class="dib-marketplace">
    <SlpContainer>
      <div v-if="data.header" class="dib-marketplace__gradient-header"></div>
      <SlpTypography
        v-if="data.header"
        variant="heading2-bold"
        tag="h2"
        class="dib-marketplace__header"
        >{{ data.header }}</SlpTypography
      >
      <SlpRow class="dib-marketplace__row">
        <SlpColumn :cols="6" class="dib-marketplace__col">
          <div v-if="data.quote" class="dib-marketplace__quote">
            <svg
              xmlns="http://www.w3.org/2000/svg"
              width="33"
              height="28"
              viewBox="0 0 33 28"
              fill="none"
            >
              <path
                d="M7.52 27.8C5.06667 27.8 3.2 26.8667 1.92 25C0.64 23.1333 0 20.5733 0 17.32C0 13.5333 0.933333 10.2 2.8 7.32C4.66667 4.44 7.52 2.06667 11.36 0.199997L13.92 5.32C11.52 6.49333 9.70667 7.90666 8.48 9.56C7.30667 11.16 6.72 13.1333 6.72 15.48C6.82667 15.4267 6.96 15.4 7.12 15.4C7.28 15.4 7.41333 15.4 7.52 15.4C9.22667 15.4 10.6667 15.9333 11.84 17C13.0667 18.0133 13.68 19.4267 13.68 21.24C13.68 23.2133 13.0933 24.8133 11.92 26.04C10.7467 27.2133 9.28 27.8 7.52 27.8ZM26.48 27.8C24.0267 27.8 22.16 26.8667 20.88 25C19.6 23.1333 18.96 20.5733 18.96 17.32C18.96 13.5333 19.8933 10.2 21.76 7.32C23.6267 4.44 26.48 2.06667 30.32 0.199997L32.88 5.32C30.48 6.49333 28.6667 7.90666 27.44 9.56C26.2667 11.16 25.68 13.1333 25.68 15.48C25.7867 15.4267 25.92 15.4 26.08 15.4C26.24 15.4 26.3733 15.4 26.48 15.4C28.1867 15.4 29.6267 15.9333 30.8 17C32.0267 18.0133 32.64 19.4267 32.64 21.24C32.64 23.2133 32.0533 24.8133 30.88 26.04C29.7067 27.2133 28.24 27.8 26.48 27.8Z"
                fill="#171321"
              />
            </svg>
            <SlpTypography tag="p" variant="quotes" class="slp-mb-24">
              {{ data.quote.text }}</SlpTypography
            >
            <div class="dib-marketplace__author">
              <img
                v-if="data.quote.image"
                class="dib-marketplace__headshot"
                :src="data.quote.image.src"
                :alt="data.quote.image.alt"
              />

              <div>
                <SlpTypography tag="p" variant="body1-bold" class="slp-mt-32">
                  {{ data.quote.name }}</SlpTypography
                >
                <SlpTypography tag="p" variant="body1">
                  {{ data.quote.role }}</SlpTypography
                >
              </div>
            </div>
          </div>
        </SlpColumn>
        <SlpColumn :cols="6" class="dib-marketplace__col">
          <SlpTypography
            v-if="data.sub_header"
            variant="heading5-bold"
            tag="h3"
            class="slp-mb-32"
            >{{ data.sub_header }}</SlpTypography
          >

          <SlpTypography variant="body1" tag="div" class="slp-mb-16">
            <SlpMarkdown :text="data.text" class="dib-marketplace__content" />
            <div v-if="data.read_more?.text" class="slp-mt-32">
              <SlpButton
                v-if="!showMore"
                class="dib-marketplace__button"
                variant="tertiary"
                @click.native="showMore = !showMore"
                >{{ data.read_more.button_text }}
                <SlpIcon icon="gl-plus" class="slp-ml-8" />
              </SlpButton>

              <Transition name="block-fade">
                <div v-if="showMore">
                  <SlpMarkdown :text="data.read_more.text" />
                  <SlpButton
                    class="dib-marketplace__button"
                    variant="tertiary"
                    @click.native="showMore = !showMore"
                    >{{ data.read_more.button_text_open }}
                    <SlpIcon icon="gl-dash" class="slp-ml-8" />
                  </SlpButton>
                </div>
              </Transition>
            </div>
          </SlpTypography>
        </SlpColumn>
      </SlpRow>
      <Faq :data="faq" data-aos="fade-right" data-aos-duration="800" />
      <div v-if="quote?.text">
        <div class="dib-marketplace__leader-quote">
          <svg
            xmlns="http://www.w3.org/2000/svg"
            width="33"
            height="28"
            viewBox="0 0 33 28"
            fill="none"
          >
            <path
              d="M7.52 27.8C5.06667 27.8 3.2 26.8667 1.92 25C0.64 23.1333 0 20.5733 0 17.32C0 13.5333 0.933333 10.2 2.8 7.32C4.66667 4.44 7.52 2.06667 11.36 0.199997L13.92 5.32C11.52 6.49333 9.70667 7.90666 8.48 9.56C7.30667 11.16 6.72 13.1333 6.72 15.48C6.82667 15.4267 6.96 15.4 7.12 15.4C7.28 15.4 7.41333 15.4 7.52 15.4C9.22667 15.4 10.6667 15.9333 11.84 17C13.0667 18.0133 13.68 19.4267 13.68 21.24C13.68 23.2133 13.0933 24.8133 11.92 26.04C10.7467 27.2133 9.28 27.8 7.52 27.8ZM26.48 27.8C24.0267 27.8 22.16 26.8667 20.88 25C19.6 23.1333 18.96 20.5733 18.96 17.32C18.96 13.5333 19.8933 10.2 21.76 7.32C23.6267 4.44 26.48 2.06667 30.32 0.199997L32.88 5.32C30.48 6.49333 28.6667 7.90666 27.44 9.56C26.2667 11.16 25.68 13.1333 25.68 15.48C25.7867 15.4267 25.92 15.4 26.08 15.4C26.24 15.4 26.3733 15.4 26.48 15.4C28.1867 15.4 29.6267 15.9333 30.8 17C32.0267 18.0133 32.64 19.4267 32.64 21.24C32.64 23.2133 32.0533 24.8133 30.88 26.04C29.7067 27.2133 28.24 27.8 26.48 27.8Z"
              fill="#171321"
            />
          </svg>
          <SlpTypography tag="p" variant="quotes" class="slp-mb-24">
            {{ quote.text }}</SlpTypography
          >
          <div class="dib-marketplace__author">
            <img
              v-if="quote.image"
              class="dib-marketplace__headshot"
              :src="quote.image.src"
              :alt="quote.image.alt"
            />

            <div>
              <SlpTypography tag="p" variant="body1-bold" class="slp-mt-32">
                {{ quote.name }}</SlpTypography
              >
              <SlpTypography tag="p" variant="body1">
                {{ quote.role }}</SlpTypography
              >
            </div>
          </div>
        </div>
      </div>
    </SlpContainer>
  </section>
</template>

<style lang="scss" scoped>
.dib-marketplace {
  margin-bottom: $spacing-48;
  @media (min-width: $breakpoint-md) {
    margin-bottom: $spacing-96;
    padding-bottom: $spacing-32;
  }

  :deep .markdown-body {
    background: transparent;
  }

  &__gradient-header {
    background: linear-gradient(90deg, #ffc8c6 0%, #b3bded 100%);
    height: 4px;
    width: 95px;
    border-radius: 10px;
    margin-bottom: $spacing-16;
  }
  &__button {
    color: $color-text-link-100;
    text-decoration: underline;
    :deep .slp-icon div {
      position: relative;
      svg {
        position: absolute;
        left: 0;
        top: 0;
      }
    }
    &:hover,
    &:focus {
      text-decoration-color: $color-text-link-100;
    }
  }
  &__quote {
    border-radius: 20px;
    background: white;
    position: relative;
    padding: $spacing-24;
    margin-bottom: 32px;

    @media screen and (min-width: $breakpoint-sm) {
      padding: $spacing-32;
      margin-bottom: 0;
    }
    &:before {
      content: '';
      position: absolute;
      width: 100%;
      border: 1px solid #171321;
      opacity: 0.20000000298023224;
      background: radial-gradient(
        50% 50% at 50% 50%,
        #fca326 0%,
        rgba(169, 137, 245, 0) 100%
      );
      z-index: -1;
      padding-bottom: 99.7%;
      border-radius: 561px;
      left: -24%;
      top: -14%;
    }
    &:after {
      content: '';
      position: absolute;

      border-radius: 100%;
      border: 1px solid #d1d0d3;
      opacity: 0.20000000298023224;
      background: radial-gradient(
        50% 50% at 50% 50%,
        #a989f5 0%,
        rgba(169, 137, 245, 0) 100%
      );
      z-index: -1;
      width: 120.3%;
      padding-bottom: 120%;
      left: -8%;
      top: -2%;
    }
    > * {
      position: relative;
      z-index: 1;
    }
  }
  &__author {
    display: flex;
  }
  &__headshot {
    border-radius: 100%;
    width: 120px;
    height: 120px;
    overflow: hidden;
    margin-right: 16px;
    flex: 0 0 120px;
    object-fit: cover;

    img {
      width: 100%;
      height: 100%;
      object-fit: cover;
    }
  }
  &__header {
    margin-bottom: 32px;
    @media screen and (min-width: $breakpoint-sm) {
      width: 47%;
      margin-bottom: 120px;
    }
  }
  &__row {
    margin-left: -32px;
  }
  &__col {
    padding-left: 32px;
  }
  &__leader-quote {
    border-radius: 20px;
    border-radius: 20px;
    background: linear-gradient(
      90deg,
      #eee7fd 0%,
      rgba(246, 243, 254, 0.83) 49.71%,
      rgba(255, 212, 216, 0.45) 100%
    );
    padding: $spacing-24;
    margin-top: 32px;
    position: relative;
    z-index: 1;
    @media screen and (min-width: $breakpoint-sm) {
      padding: $spacing-32;
    }
  }
  :deep {
    .slp-full-light-purple-background {
      background: transparent;
      .slp-container {
        padding: 0;
      }
    }
    .faq__group-header--has-header {
      border-bottom: 1px solid #d1d0d3;
    }
    .slp-faq {
      padding: 0 !important;
      @media screen and (min-width: $breakpoint-sm) {
        padding: 96px 0px !important;
      }
    }
    .faq__title {
      margin-bottom: 0;
      padding-right: 0;
      @media screen and (min-width: $breakpoint-sm) {
        padding-right: 48px;
      }
    }
    .faq__container {
      @media screen and (max-width: $breakpoint-sm) {
        margin-top: 0;
      }
    }
    .jump_button {
      display: none;
    }
    .faq__header {
      display: none;
    }
  }
  .block-fade-enter-active {
    transition: all 0.5s;
  }

  .block-fade-leave-active {
    transition: all 0.3s ease-in;
  }

  .block-fade-enter,
  .block-fade-leave-to {
    transform: translateY(20px);
    opacity: 0;
    @media (prefers-reduced-motion) {
      opacity: 1;
      transform: none;
    }
  }
  .block-fade-leave,
  .block-fade-enter-to {
    opacity: 1;
  }
  &__content {
    :deep h3 {
      font-size: 24px;
      font-weight: 600;
      letter-spacing: -0.6px;
      line-height: 32px;
    }
  }
}
</style>
